/*
  ( )
 SMcolor.
 . . , 2001
  ,   
  -     
E-mail: super-m@narod.ru
Web: super-m.narod.ru
*/

#include <windows.h>
#include "smcolor.h"
#include <stdio.h>
#include <stdlib.h>
//#include <io.h>

/*******************  Global Variables ********************/

HANDLE ghInstance;
UINT timerID=1000;
HWND hDskWnd;
HWND hwndStatic_r, hwndStatic_g, hwndStatic_b;
HWND hwndStatic_c, hwndStatic_m, hwndStatic_y, hwndStatic_k;
HWND hwndStatic_cref, hwndStatic_web, hwndStatic_tcol;
HWND hwndEdit_r, hwndEdit_g, hwndEdit_b;
HWND hwndEdit_c, hwndEdit_m, hwndEdit_y, hwndEdit_k;
HWND hwndEdit_cref, hwndEdit_web;
HWND hwndStatic_xy;

/*********************  Prototypes  ***********************/
LRESULT WINAPI MainWndProc( HWND, UINT, WPARAM, LPARAM );
void ProcTimer(void);


///********************************************************************
///*  Function: int PASCAL WinMain(HINSTANCE, HINSTANCE, LPSTR, int)    *
///*                                                                    *
///*   Purpose: Initializes Application                                 *

///*  Comments: Register window class, create and display the main      *
///*            window, and enter message loop.                         *
///*                                                                    *
///********************************************************************/

int PASCAL WinMain( HINSTANCE hInstance,
    HINSTANCE hPrevInstance,

    LPSTR lpszCmdLine,
    int nCmdShow )
{
   WNDCLASS wc;
   MSG msg;
   HWND hWnd;

   if( !hPrevInstance )
   {
      wc.lpszClassName = "SmColorAppClass";
      wc.lpfnWndProc = MainWndProc;
      wc.style = CS_OWNDC;
      wc.hInstance = hInstance;
      wc.hIcon = LoadIcon( hInstance, MAKEINTRESOURCE(IDI_WINFCOMPICON) );
      wc.hCursor = LoadCursor( hInstance, MAKEINTRESOURCE(IDC_WINFCOMPCURSOR) );
      wc.hbrBackground = (HBRUSH)( COLOR_BTNFACE+1 );
      wc.lpszMenuName = /*"GenericAppMenu"*/NULL;

      wc.cbClsExtra = 0;
      wc.cbWndExtra = 0;

      RegisterClass( &wc );
   }

   ghInstance = hInstance;

   hWnd = CreateWindow( "SmColorAppClass",
      "SMcolor",
      WS_OVERLAPPED|WS_CAPTION|WS_SYSMENU|WS_MINIMIZEBOX,
      0,
      0,
      300,
      245,
      NULL,
      NULL,
      hInstance,
      NULL
   );

   ShowWindow( hWnd, nCmdShow );
   hDskWnd=GetDesktopWindow();
   timerID=SetTimer(hWnd, timerID, 100, NULL);

   while( GetMessage( &msg, NULL, 0, 0 ) ) {
      TranslateMessage( &msg );

      DispatchMessage( &msg );
   }
   if (timerID!=0) KillTimer(hWnd, timerID);

   return msg.wParam;
}

///********************************************************************
///* Function: LRESULT CALLBACK MainWndProc(HWND, UINT, WPARAM, LPARAM) *
///*                                                                    *
///*  Purpose: Processes Application Messages                           *
///*                                                                    *
///* Comments: The following messages are processed                     *

///*           WM_COMMAND                                               *
///*           WM_CREATE                                                *
///*           WM_TIMER                                                 *
///*           WM_DESTROY                                               *
///*                                                                    *
///********************************************************************/

LRESULT CALLBACK MainWndProc( HWND hWnd, UINT msg, WPARAM wParam,
   LPARAM lParam )
{
   HDC hDC;
   static HWND hwndButtonInfo;
   WORD wNotifyCode, wID;
   wNotifyCode = HIWORD(wParam); // notification code
   wID = LOWORD(wParam);

   switch( msg ) {

      case WM_CREATE:
         hwndStatic_r = CreateWindow(
                "STATIC",     /* predefined class  */
                "R:",       /*  window title  */
                WS_CHILD | WS_VISIBLE | SS_LEFT,
                10, 10, 20, 30, /* set size  */
                hWnd,       /* parent window  */
                (HMENU) ID_STATIC1, /* edit control ID  */
                (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
                NULL);
         hwndEdit_r = CreateWindow(
                "EDIT",     /* predefined class  */
                NULL,       /* no window title  */
                WS_TABSTOP | WS_CHILD | WS_VISIBLE | ES_LEFT | ES_READONLY,
                30, 10, 80, 20, /* set size  */
                hWnd,       /* parent window  */
                (HMENU) ID_EDITCHILD, /* edit control ID */
                (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
                NULL);
         hwndStatic_g = CreateWindow(
                "STATIC",     /* predefined class                  */
                "G:",       /*  window title    */
                WS_CHILD | WS_VISIBLE | SS_LEFT,
                10, 40, 20, 30, /* set size     */
                hWnd,       /* parent window                     */
                (HMENU) ID_STATIC2, /* edit control ID         */
                (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
                NULL);
         hwndEdit_g = CreateWindow(
                "EDIT",     /* predefined class  */
                NULL,       /* no window title  */
                WS_TABSTOP | WS_CHILD | WS_VISIBLE | ES_LEFT | ES_READONLY,
                30, 40, 80, 20, /* set size  */
                hWnd,       /* parent window  */
                (HMENU) ID_EDITCHILD, /* edit control ID */
                (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
                NULL);
         hwndStatic_b = CreateWindow(
                "STATIC",     /* predefined class                  */
                "B:",       /*  window title    */
                WS_CHILD | WS_VISIBLE | SS_LEFT,
                10, 70, 20, 30, /* set size     */
                hWnd,       /* parent window                     */
                (HMENU) ID_STATIC2, /* edit control ID         */
                (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
                NULL);
         hwndEdit_b = CreateWindow(
                "EDIT",     /* predefined class  */
                NULL,       /* no window title  */
                WS_TABSTOP | WS_CHILD | WS_VISIBLE | ES_LEFT | ES_READONLY,
                30, 70, 80, 20, /* set size  */
                hWnd,       /* parent window  */
                (HMENU) ID_EDITCHILD, /* edit control ID */
                (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
                NULL);
         hwndStatic_c = CreateWindow(
                "STATIC",     /* predefined class                  */
                "C:",       /*  window title    */
                WS_CHILD | WS_VISIBLE | SS_LEFT,
                120, 10, 20, 30, /* set size     */
                hWnd,       /* parent window                     */
                (HMENU) ID_STATIC2, /* edit control ID         */
                (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
                NULL);
         hwndEdit_c = CreateWindow(
                "EDIT",     /* predefined class  */
                NULL,       /* no window title  */
                WS_TABSTOP | WS_CHILD | WS_VISIBLE | ES_LEFT | ES_READONLY,
                140, 10, 80, 20, /* set size  */
                hWnd,       /* parent window  */
                (HMENU) ID_EDITCHILD, /* edit control ID */
                (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
                NULL);
         hwndStatic_m = CreateWindow(
                "STATIC",     /* predefined class                  */
                "M:",       /*  window title    */
                WS_CHILD | WS_VISIBLE | SS_LEFT,
                120, 40, 20, 30, /* set size     */
                hWnd,       /* parent window                     */
                (HMENU) ID_STATIC2, /* edit control ID         */
                (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
                NULL);
         hwndEdit_m = CreateWindow(
                "EDIT",     /* predefined class  */
                NULL,       /* no window title  */
                WS_TABSTOP | WS_CHILD | WS_VISIBLE | ES_LEFT | ES_READONLY,
                140, 40, 80, 20, /* set size  */
                hWnd,       /* parent window  */
                (HMENU) ID_EDITCHILD, /* edit control ID */
                (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
                NULL);
         hwndStatic_y = CreateWindow(
                "STATIC",     /* predefined class                  */
                "Y:",       /*  window title    */
                WS_CHILD | WS_VISIBLE | SS_LEFT,
                120, 70, 20, 30, /* set size     */
                hWnd,       /* parent window                     */
                (HMENU) ID_STATIC2, /* edit control ID         */
                (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
                NULL);
         hwndEdit_y = CreateWindow(
                "EDIT",     /* predefined class  */
                NULL,       /* no window title  */
                WS_TABSTOP | WS_CHILD | WS_VISIBLE | ES_LEFT | ES_READONLY,
                140, 70, 80, 20, /* set size  */
                hWnd,       /* parent window  */
                (HMENU) ID_EDITCHILD, /* edit control ID */
                (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
                NULL);
         hwndStatic_k = CreateWindow(
                "STATIC",     /* predefined class                  */
                "K:",       /*  window title    */
                WS_CHILD | WS_VISIBLE | SS_LEFT,
                120, 100, 20, 30, /* set size     */
                hWnd,       /* parent window                     */
                (HMENU) ID_STATIC2, /* edit control ID         */
                (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
                NULL);
         hwndEdit_k = CreateWindow(
                "EDIT",     /* predefined class  */
                NULL,       /* no window title  */
                WS_TABSTOP | WS_CHILD | WS_VISIBLE | ES_LEFT | ES_READONLY,
                140, 100, 80, 20, /* set size  */
                hWnd,       /* parent window  */
                (HMENU) ID_EDITCHILD, /* edit control ID */
                (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
                NULL);
         hwndStatic_cref = CreateWindow(
                "STATIC",     /* predefined class                  */
                "COLORREF:",       /*  window title    */
                WS_CHILD | WS_VISIBLE | SS_LEFT,
                10, 130, 80, 30, /* set size     */
                hWnd,       /* parent window                     */
                (HMENU) ID_STATIC2, /* edit control ID         */
                (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
                NULL);
         hwndEdit_cref = CreateWindow(
                "EDIT",     /* predefined class  */
                NULL,       /* no window title  */
                WS_BORDER | WS_CHILD | WS_VISIBLE | ES_LEFT | WS_TABSTOP,
                100, 130, 120, 20, /* set size  */
                hWnd,       /* parent window  */
                (HMENU) ID_EDITCHILD, /* edit control ID */
                (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
                NULL);
         hwndStatic_web = CreateWindow(
                "STATIC",     /* predefined class                  */
                "Web:",       /*  window title    */
                WS_CHILD | WS_VISIBLE | SS_LEFT,
                50, 160, 50, 30, /* set size     */
                hWnd,       /* parent window                     */
                (HMENU) ID_STATIC2, /* edit control ID         */
                (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
                NULL);
         hwndEdit_web = CreateWindow(
                "EDIT",     /* predefined class  */
                NULL,       /* no window title  */
                WS_BORDER | WS_CHILD | WS_VISIBLE | ES_LEFT | WS_TABSTOP,
                100, 160, 120, 20, /* set size  */
                hWnd,       /* parent window  */
                (HMENU) ID_EDITCHILD, /* edit control ID */
                (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
                NULL);
         hwndStatic_xy = CreateWindow(
                "STATIC",     /* predefined class                  */
                "",       /*  window title    */
                WS_CHILD | WS_VISIBLE | SS_LEFT,
                10, 200, 180, 30, /* set size     */
                hWnd,       /* parent window                     */
                (HMENU) ID_STATIC2, /* edit control ID         */
                (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
                NULL);
         hwndButtonInfo = CreateWindow(
                "BUTTON",     /* predefined class                  */
                " ",       /*  window title    */
                WS_BORDER | WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON |
                BS_CENTER | BS_VCENTER,
                200, 185, 90, 30, /* set size     */
                hWnd,       /* parent window                     */
                (HMENU) ID_BUTTON2, /* edit control ID         */
                (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
                NULL);
         break;
//     WM_COMMAND:

      case WM_COMMAND:
         if (wNotifyCode==BN_CLICKED)
         {
           switch( wID )
           {
            case ID_BUTTON2:
      SetWindowText(hwndEdit_g, "green");
               MessageBox( hWnd,
                 " \n"
                 "  .\n 0.1  "__DATE__"\n"
                 "  Super-M\n(. . )\n"
                 "E-mail: super-m@narod.ru\n"
                 ": super-m.narod.ru",
                 "  SMcolor",
                 MB_OK | MB_ICONASTERISK );
            break;
           }//end switch
         }//end if
      break;

//     WM_TIMER:
      case WM_TIMER:
        ProcTimer();
      break;


//     WM_DESTROY: PostQuitMessage() is called

      case WM_DESTROY:
         PostQuitMessage( 0 );
         break;

//     Let the default window proc handle all other messages

      default:
         return( DefWindowProc( hWnd, msg, wParam, lParam ));

   }

   return 0;
}//end MainWndProc

void ProcTimer(void)
{
  POINT pnt;
  COLORREF c;
  HDC dsk_dc;
  PAINTSTRUCT ps;
  char buf[128]; //buffer for numbers
  int r_val, g_val, b_val, c_val, m_val, y_val, k_val, w_col;
  GetCursorPos(&pnt);
  dsk_dc=GetWindowDC(hDskWnd);
  c=GetPixel(dsk_dc, (int)pnt.x, (int)pnt.y);
  ReleaseDC(hDskWnd, dsk_dc);
  r_val=GetRValue(c);
  g_val=GetGValue(c);
  b_val=GetBValue(c);
  c_val=GetCValue(c);
  m_val=GetMValue(c);
  y_val=GetYValue(c);
  k_val=GetKValue(c);
  w_col=(r_val<<16)+(g_val<<8)+b_val;
  sprintf(buf, "0x%X=%d", r_val, r_val);
  SetWindowText(hwndEdit_r, buf);
  sprintf(buf, "0x%X=%d", g_val, g_val);
  SetWindowText(hwndEdit_g, buf);
  sprintf(buf, "0x%X=%d", b_val, b_val);
  SetWindowText(hwndEdit_b, buf);
  sprintf(buf, "0x%X=%d", c_val, c_val);
  SetWindowText(hwndEdit_c, buf);
  sprintf(buf, "0x%X=%d", m_val, m_val);
  SetWindowText(hwndEdit_m, buf);
  sprintf(buf, "0x%X=%d", y_val, y_val);
  SetWindowText(hwndEdit_y, buf);
  sprintf(buf, "0x%X=%d", k_val, k_val);
  SetWindowText(hwndEdit_k, buf);
  sprintf(buf, "x=%d; y=%d", (int)pnt.x, (int)pnt.y);
  SetWindowText(hwndStatic_xy, buf);
  sprintf(buf, "0x%X", (int)c);
  SetWindowText(hwndEdit_cref, buf);
  sprintf(buf, "#%06X", w_col);
  SetWindowText(hwndEdit_web, buf);
}//end ProcTimer